/* ccgo: igs/parser/parser.cc
 * 
 * Copyright 2002 Chun-Chung Chen <cjj@u.washington.edu>
 * 
 * This program is free software; you can redistribute it and'or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

#include "parser.hh"
#include <iostream>

using namespace igs;

std::vector<Parser *> * Parser::parser_list = 0;

Parser * Parser::list_holder = 0;
extern Parser parser;
Parser parser(& parser);

std::vector<Parser *> & Parser::get_parser_list()
{
	if (! parser_list) {
		parser_list = new std::vector <Parser *>;
		list_holder = this;
	}
	return * parser_list;
}

Parser * Parser::id(Control * c) const
{
	return 0;
}

Parser * Parser::search_id(Control * c)
{
	if (! parser_list) return 0;
	for (std::vector<Parser *>::const_iterator i = parser_list->begin(); i != parser_list->end(); i ++) {
		Parser * p = (* i)->id(c);
		if (p == * i) return 0; // processed and complete
		if (p) return p;
	}
	std::cerr << "no parser for message: >" << c->get_line() << "<" << std::endl;
	return 0;
}

Parser::Parser(Parser * p)
{
	get_parser_list().push_back(p);
}

Parser::Parser(Control * c)
{
	control = c;
}

Parser::~Parser()
{
	if (list_holder == this) delete parser_list;
}

bool Parser::process()
{
	return false;
}
